<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>event_xmlrpc Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id247984"></a>event_xmlrpc Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Razvan</span> <span class="surname">Crainea</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Razvan</span> <span class="surname">Crainea</span></h3></div></div></div><div><p class="copyright">Copyright © 2012 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id293635">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id284362">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248333">1.2. XMLRPC socket syntax</a></span></dt><dt><span class="section"><a href="#id248954">1.3. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248959">1.3.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248985">1.3.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249011">1.4. Exported Parameters</a></span></dt><dt><span class="section"><a href="#id249020">1.5. Exported Functions</a></span></dt><dt><span class="section"><a href="#id249030">1.6. Example</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249040">E_PIKE_BLOCKED event</a></dt><dt>1.2. <a href="#id249055">XMLRPC socket</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id293635"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284362"></a>1.1. Overview</h2></div></div></div><p>
		This module is an implementation of an XMLRPC client used to notify
		XMLRPC servers whenever certain notifications are raised by OpenSIPS. It
		acts as a transport layer for the Event Notification Interface.
	</p><p>
		Basicly, the module executes a remote procedure call when an event is
		raised from OpenSIPS's script, core or modules using the Event
		Interface.
	</p><p>
		In order to be notified, an XMLRPC server has to subscribe for a certain
		event provided by OpenSIPS. This can be done using the generic MI
		Interface (<span class="emphasis"><em>event_subscribe</em></span> function) or from
		OpenSIPS script (<span class="emphasis"><em>subscribe_event</em></span> core function).
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248333"></a>1.2. XMLRPC socket syntax</h2></div></div></div><p>
		</p><p><span class="emphasis"><em>'xmlrpc:' host ':' port ':' method</em></span></p><p>
	</p><p>
		Meanings:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
					<span class="emphasis"><em>'xmlrpc:'</em></span> - informs the Event Interface
					that the events sent to this subscriber should be handled
					by the <span class="emphasis"><em>event_xmlrpc</em></span> module.
			</p></li><li><p>
					<span class="emphasis"><em>host</em></span> - host name of the XMLRPC server.
			</p></li><li><p>
					<span class="emphasis"><em>port</em></span> - port of the XMLRPC server.
			</p></li><li><p>
					<span class="emphasis"><em>method</em></span> - method called remotely by the
					XMLRPC client.
					</p><p>NOTE: the client does not wait for a response from the
						XMLRPC server.</p><p>
			</p></li></ul></div><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248954"></a>1.3. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248959"></a>1.3.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>none</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248985"></a>1.3.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>none</em></span>
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249011"></a>1.4. Exported Parameters</h2></div></div></div><p>
		No parameter exported by this module.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249020"></a>1.5. Exported Functions</h2></div></div></div><p>
		No function exported to be used from configuration file.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249030"></a>1.6. Example</h2></div></div></div><p>
			This is an example of an event raised by the pike module
			when it decides an ip should be blocked:
		</p><div class="example"><a name="id249040"></a><p class="title"><b>Example 1.1. E_PIKE_BLOCKED event</b></p><div class="example-contents"><pre class="programlisting">


POST /RPC2 HTTP/1.1.
Host: 127.0.0.1:8081.
Connection: close.
User-Agent: OpenSIPS XMLRPC Notifier.
Content-type: text/xml.
Content-length: 240.
		.
&lt;?xml version="1.0"?&gt;
&lt;methodCall&gt;
	&lt;methodName&gt;e_dummy_h&lt;/methodName&gt;
	&lt;params&gt;
		&lt;param&gt;
			&lt;value&gt;&lt;string&gt;E_MY_EVENT&lt;/string&gt;&lt;/value&gt;
		&lt;/param&gt;
		&lt;param&gt;
			&lt;name&gt;ip&lt;/name&gt;
			&lt;value&gt;&lt;string&gt;192.168.2.11&lt;/string&gt;&lt;/value&gt;
		&lt;/param&gt;
	&lt;/params&gt;
&lt;/methodCall&gt;

</pre></div></div><br class="example-break"><div class="example"><a name="id249055"></a><p class="title"><b>Example 1.2. XMLRPC socket</b></p><div class="example-contents"><pre class="programlisting">

	# calls the 'block_ip' function
	xmlrpc:127.0.0.1:8080:block_ip

</pre></div></div><br class="example-break"></div></div></div></body></html>
