<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>gflags Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id247984"></a>gflags Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Jiri</span> <span class="surname">Kuthan</span></h3><code class="email">&lt;<a class="email" href="mailto:jiri@iptel.org">jiri@iptel.org</a>&gt;</code></div><div class="author"><h3 class="author"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3><code class="email">&lt;<a class="email" href="mailto:bogdan@opensips.org">bogdan@opensips.org</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Daniel-Constantin</span> <span class="surname">Mierla</span></h3><code class="email">&lt;<a class="email" href="mailto:miconda@gmail.com">miconda@gmail.com</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2004 FhG FOKUS</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id275287">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id271126">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id258913">1.2. Dependencies</a></span></dt><dt><span class="section"><a href="#id275530">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248014">1.3.1. <code class="varname">initial</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id248950">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id248956">1.4.1. <code class="function">set_gflag(flag)</code></a></span></dt><dt><span class="section"><a href="#id249000">1.4.2. <code class="function">reset_gflag(flag)</code></a></span></dt><dt><span class="section"><a href="#id249046">1.4.3. <code class="function">is_gflag(flag)</code></a></span></dt></dl></dd><dt><span class="section"><a href="#id249093">1.5. <acronym class="acronym">MI</acronym> Commands</a></span></dt><dd><dl><dt><span class="section"><a href="#id249107">1.5.1. <code class="function">set_gflag</code></a></span></dt><dt><span class="section"><a href="#id249141">1.5.2. <code class="function">reset_gflag</code></a></span></dt><dt><span class="section"><a href="#id249176">1.5.3. <code class="function">is_gflag</code></a></span></dt><dt><span class="section"><a href="#id249977">1.5.4. <code class="function">get_gflags</code></a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248934"><code class="varname">initial</code> parameter usage</a></dt><dt>1.2. <a href="#id248983"><code class="function">set_gflag()</code> usage</a></dt><dt>1.3. <a href="#id249028"><code class="function">reset_gflag()</code> usage</a></dt><dt>1.4. <a href="#id249073"><code class="function">is_gflag()</code> usage</a></dt><dt>1.5. <a href="#id249123"><code class="function">set_gflag</code> usage</a></dt><dt>1.6. <a href="#id249158">
				<code class="function">reset_gflag</code> usage</a></dt><dt>1.7. <a href="#id249957"><code class="function">is_gflag</code> usage</a></dt><dt>1.8. <a href="#id249991">
				<code class="function">get_gflags</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id275287"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id271126"></a>1.1. Overview</h2></div></div></div><p>
	gflags module (global flags) keeps a bitmap of flags in shared memory
	and may be used to change behaviour of server based on value of the flags.
	Example:
	</p><pre class="programlisting">
	if (is_gflag("1")) {
		t_relay("udp:10.0.0.1:5060");
	} else {
		t_relay("udp:10.0.0.2:5060");
	}
	</pre><p>
	</p><p>
	The benefit of this module is the value of the switch flags
	can be manipulated by external applications such as web interface
	or command line tools. The size of bitmap is 32.
	</p><p>
	The module exports external commands that can be used to change
	the global flags via Management Interface. The MI commands are:
	&#8220;<span class="quote">set_gflag</span>&#8221;, &#8220;<span class="quote">reset_gflag</span>&#8221; and
	&#8220;<span class="quote">is_gflag</span>&#8221;.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id258913"></a>1.2. Dependencies</h2></div></div></div><p>
		The module depends on the following modules (in the other words the
		listed modules must be loaded before this module):
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>none</em></span></p></li></ul></div><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id275530"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248014"></a>1.3.1. <code class="varname">initial</code> (integer)</h3></div></div></div><p>
		The initial value of global flags bitmap.
		</p><p>
		Default value is &#8220;<span class="quote">0</span>&#8221;.
		</p><div class="example"><a name="id248934"></a><p class="title"><b>Example 1.1. <code class="varname">initial</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
modparam("gflags", "initial", 15)
		</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248950"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248956"></a>1.4.1. <code class="function">set_gflag(flag)</code></h3></div></div></div><p>
		Set the bit at the position &#8220;<span class="quote">flag</span>&#8221; in global flags.
		</p><p>
		&#8220;<span class="quote">flag</span>&#8221; can have a value in the range of 0..31.
		</p><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE,
		ONREPLY_ROUTE, BRANCH_ROUTE and LOCAL_ROUTE.
		</p><div class="example"><a name="id248983"></a><p class="title"><b>Example 1.2. <code class="function">set_gflag()</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
set_gflag("4");
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249000"></a>1.4.2. <code class="function">reset_gflag(flag)</code></h3></div></div></div><p>
		Reset the bit at the position &#8220;<span class="quote">flag</span>&#8221; in global flags.
		</p><p>
		&#8220;<span class="quote">flag</span>&#8221; can have a value in the range of 0..31.
		</p><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE,
		ONREPLY_ROUTE, BRANCH_ROUTE and LOCAL_ROUTE.
		</p><div class="example"><a name="id249028"></a><p class="title"><b>Example 1.3. <code class="function">reset_gflag()</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
reset_gflag("4");
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249046"></a>1.4.3. <code class="function">is_gflag(flag)</code></h3></div></div></div><p>
		Check if bit at the position &#8220;<span class="quote">flag</span>&#8221; in global flags is
		set.
		</p><p>
		&#8220;<span class="quote">flag</span>&#8221; can have a value in the range of 0..31.
		</p><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE,
		ONREPLY_ROUTE, BRANCH_ROUTE and LOCAL_ROUTE.
		</p><div class="example"><a name="id249073"></a><p class="title"><b>Example 1.4. <code class="function">is_gflag()</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if(is_gflag("4"))
{
	log("global flag 4 is set\n");
} else {
	log("global flag 4 is not set\n");
};
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249093"></a>1.5. <acronym class="acronym">MI</acronym> Commands</h2></div></div></div><p>Functions that check or change some flags accepts one parameter 
			which is the flag bitmap/mask specifing the corresponding flags.
			It is not possible to specify directly the flag position that 
			should be changed as in the functions available in the routing 
			script.
		</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249107"></a>1.5.1. <code class="function">set_gflag</code></h3></div></div></div><p>
			Set the value of some flags (specified by bitmask) to 1.
			</p><p>
			The parameter value must be a bitmask in decimal or hexa format.
			The bitmaks has a 32 bit size.
			</p><div class="example"><a name="id249123"></a><p class="title"><b>Example 1.5. <code class="function">set_gflag</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
$ opensipsctl fifo set_gflag 1
$ opensipsctl fifo set_gflag 0x3
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249141"></a>1.5.2. <code class="function">reset_gflag</code></h3></div></div></div><p>
			Reset the value of some flags to 0.
			</p><p>
			The parameter value must be a bitmask in decimal or hexa format.
			The bitmaks has a 32 bit size.
			</p><div class="example"><a name="id249158"></a><p class="title"><b>Example 1.6. 
				<code class="function">reset_gflag</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
$ opensipsctl fifo reset_gflag 1
$ opensipsctl fifo reset_gflag 0x3
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249176"></a>1.5.3. <code class="function">is_gflag</code></h3></div></div></div><p>
			Returns true if the all the flags from the bitmask are set.
			</p><p>
			The parameter value must be a bitmask in decimal or hexa format.
			The bitmaks has a 32 bit size.
			</p><p>
			The function returns TRUE if all the flags from the set are set
			and FALSE if at least one is not set.
			</p><div class="example"><a name="id249957"></a><p class="title"><b>Example 1.7. <code class="function">is_gflag</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
$ opensipsctl fifo set_gflag 1024
$ opensipsctl fifo is_gflag 1024
TRUE
$ opensipsctl fifo is_gflag 1025
TRUE
$ opensipsctl fifo is_gflag 1023
FALSE
$ opensipsctl fifo set_gflag 0x10
$ opensipsctl fifo is_gflag 1023
TRUE
$ opensipsctl fifo is_gflag 1007
FALSE
$ opensipsctl fifo is_gflag 16
TRUE
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249977"></a>1.5.4. <code class="function">get_gflags</code></h3></div></div></div><p>
			Return the bitmap with all flags. The function gets no 
			parameters and returns the bitmap in hexa and decimal format.
			</p><div class="example"><a name="id249991"></a><p class="title"><b>Example 1.8. 
				<code class="function">get_gflags</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
$ opensipsctl fifo get_gflags
0x3039
12345
...
</pre></div></div><br class="example-break"></div></div></div></div></body></html>
