<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>httpd Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id248507"></a>httpd Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3><code class="email">&lt;<a class="email" href="mailto:osas@voipembedded.com">osas@voipembedded.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3></div></div></div><div><p class="copyright">Copyright © 2012 
		<a class="ulink" href="http://www.voipembedded.com" target="_top">VoIP Embedded, Inc.</a>
	    </p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Rev: 8580 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id274405">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id282220">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id271914">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id284368">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248313">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248015">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248021">1.3.1. <code class="varname">ip</code>(string)</a></span></dt><dt><span class="section"><a href="#id248952">1.3.2. <code class="varname">port</code>(integer)</a></span></dt><dt><span class="section"><a href="#id248986">1.3.3. <code class="varname">buf_size</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249028">1.4. Exported MI Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id249033">1.4.1. <code class="varname">httpd_list_root_path</code></a></span></dt></dl></dd><dt><span class="section"><a href="#id249067">1.5. Exported Functions</a></span></dt><dt><span class="section"><a href="#id249076">1.6. Known issues</a></span></dt></dl></dd><dt><span class="chapter"><a href="#id248894">2. Developer Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id248852">2.1. Available Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id248857">2.1.1. 
		<code class="function">register_httpdcb (module, root_path, httpd_acces_handler_cb, httpd_flush_data_cb, httpd_init_proc_cb)</code>
		</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248932">Set <code class="varname">ip</code> parameter</a></dt><dt>1.2. <a href="#id248970">Set <code class="varname">port</code> parameter</a></dt><dt>1.3. <a href="#id249010">Set <code class="varname">buf_size</code> parameter</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id274405"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id282220"></a>1.1. Overview</h2></div></div></div><p>
		This module provides an HTTP transport layer for OpenSIPS.
	</p><p>
		Implementation of httpd module's http server is based on 
		libmicrohttpd library.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id271914"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id284368"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248313"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>libmicrohttpd</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248015"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248021"></a>1.3.1. <code class="varname">ip</code>(string)</h3></div></div></div><p>
		The IP address used by the HTTP server to listen for incoming 
		requests.
		</p><p>
		<span class="emphasis"><em>The default value is an empty string.</em></span>
		If no IP address is set, then the http server
		will bind to all available IPs.
		</p><div class="example"><a name="id248932"></a><p class="title"><b>Example 1.1. Set <code class="varname">ip</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("httpd", "ip", "127.0.0.1")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248952"></a>1.3.2. <code class="varname">port</code>(integer)</h3></div></div></div><p>
		The port number used by the HTTP server to listen for incoming 
		requests.
		</p><p>
		<span class="emphasis"><em>The default value is 8888.</em></span>
		Ports lower than 1024 are not accepted.
		</p><div class="example"><a name="id248970"></a><p class="title"><b>Example 1.2. Set <code class="varname">port</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("httpd", "port", 8000)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248986"></a>1.3.3. <code class="varname">buf_size</code> (integer)</h3></div></div></div><p>
		It specifies the maximum length (in bytes) of the buffer
		used to write in the html response.
		</p><p>
		If the size of the buffer is set to zero, it will be automatically
		set to a quarter of the size of the pkg memory.
		</p><p>
		<span class="emphasis"><em> The default value is 0.</em></span>
		</p><div class="example"><a name="id249010"></a><p class="title"><b>Example 1.3. Set <code class="varname">buf_size</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("httpd", "buf_size", 524288)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249028"></a>1.4. Exported MI Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249033"></a>1.4.1. <code class="varname">httpd_list_root_path</code></h3></div></div></div><p>
		Lists all the registered http root paths into the httpd module.
		When a request comes in, if the root parth is in the list,
		the request will be sent to the module that register it.
		</p><p>
		Name: <span class="emphasis"><em>httpd_list_root_path</em></span>
		</p><p>Parameters: none</p><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
:httpd_list_root_path:_reply_fifo_file_
_empty_line_
		</pre></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249067"></a>1.5. Exported Functions</h2></div></div></div><p>
		No function exported to be used from configuration file.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249076"></a>1.6. Known issues</h2></div></div></div><p>
		Due to the fact that OpenSIPS is a multiprocess application,
		the microhttpd library is used in "external select" mode.
		This ensures that the library is not running in
		multithread mode and the library is entirely controled
		by OpenSIPS.  Due to this particular mode of operations,
		for now, the entire http response is built in a pre-allocated
		buffer (see buf_size parameter).
		</p><p>
		Future realeases of this module will address this issue.
		</p><p>
		Running the http daemon as non root on ports below 1024 is
		forbidden by default in linux (kernel&gt;=2.6.24).
		To allow the port binding, one can use
		<span class="emphasis"><em>setcap</em></span> to give
		extra privilleges to opensips binary:
		</p><pre class="programlisting">
setcap 'cap_net_bind_service=+ep' /usr/local/sbin/opensips
		</pre><p>
		</p></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id248894"></a>Chapter 2. Developer Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248852"></a>2.1. Available Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248857"></a>2.1.1. 
		<code class="function">register_httpdcb (module, root_path, httpd_acces_handler_cb, httpd_flush_data_cb, httpd_init_proc_cb)</code>
		</h3></div></div></div><p>
		Register a new http root with it's associated callbacks into the httpd module.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>const char *mod</em></span>
			- name of the module that register an http root path to be handled;
			</p></li><li><p><span class="emphasis"><em>str *root_path</em></span>
			- the registered root path;
			</p></li><li><p><span class="emphasis"><em>httpd_acces_handler_cb f1</em></span>
			- handler to the callback method to be called on root path match;
			</p></li><li><p><span class="emphasis"><em>httpd_flush_data_cb f2</em></span>
			- handler to the callback method to be called for sending extra data (at a later time);
			</p></li><li><p><span class="emphasis"><em>httpd_init_proc_cb f3</em></span>
			- handler to the callback method to be called during httpd process init;
			</p></li></ul></div></div></div></div></div></body></html>
