<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Load-Balancer Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id247987"></a>Load-Balancer Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Bogdan-Andrei</span> <span class="surname">Iancu</span></h3></div></div></div><div><p class="copyright">Copyright © 2009 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id280732">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id276486">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248311">1.2. How it works</a></span></dt><dt><span class="section"><a href="#id248002">1.3. Probing and Disabling destinations</a></span></dt><dt><span class="section"><a href="#id248970">1.4. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248976">1.4.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249019">1.4.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249045">1.5. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249050">1.5.1. <code class="varname">db_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id249075">1.5.2. <code class="varname">db_table</code> (string)</a></span></dt><dt><span class="section"><a href="#id249117">1.5.3. <code class="varname">probing_interval</code> (integer)</a></span></dt><dt><span class="section"><a href="#id249157">1.5.4. <code class="varname">probing_method</code> (string)</a></span></dt><dt><span class="section"><a href="#id249969">1.5.5. <code class="varname">probing_from</code> (string)</a></span></dt><dt><span class="section"><a href="#id250008">1.5.6. <code class="varname">probing_reply_codes</code> (string)</a></span></dt><dt><span class="section"><a href="#id250049">1.5.7. <code class="varname">lb_define_blacklist</code> (string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id250095">1.6. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id250100">1.6.1. 
		<code class="function">load_balance(grp,resources[,alg])</code>
		</a></span></dt><dt><span class="section"><a href="#id250205">1.6.2. 
		<code class="function">lb_disable()</code>
		</a></span></dt><dt><span class="section"><a href="#id250246">1.6.3. 
		<code class="function">lb_is_destination(ip,port[,group[,active]])</code>
		</a></span></dt><dt><span class="section"><a href="#id250325">1.6.4. 
		<code class="function">lb_count_call(ip,port,grp,resources)</code>
		</a></span></dt></dl></dd><dt><span class="section"><a href="#id250411">1.7. Exported statistics</a></span></dt><dt><span class="section"><a href="#id250421">1.8. Exported MI Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id250427">1.8.1. <code class="varname">lb_reload</code></a></span></dt><dt><span class="section"><a href="#id250447">1.8.2. <code class="varname">lb_resize</code></a></span></dt><dt><span class="section"><a href="#id250470">1.8.3. <code class="varname">lb_list</code></a></span></dt><dt><span class="section"><a href="#id248867">1.8.4. <code class="varname">lb_status</code></a></span></dt></dl></dd><dt><span class="section"><a href="#id248910">1.9. Exported pseudo-variables</a></span></dt></dl></dd><dt><span class="chapter"><a href="#id294728">2. Developer Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id294733">2.1. Available Functions</a></span></dt></dl></dd><dt><span class="chapter"><a href="#id294696">3. Frequently Asked Questions</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249071">Set <code class="varname">db_url</code> parameter</a></dt><dt>1.2. <a href="#id249098">Set <code class="varname">db_table</code> parameter</a></dt><dt>1.3. <a href="#id249140">Set <code class="varname">probing_interval</code> parameter</a></dt><dt>1.4. <a href="#id249952">Set <code class="varname">probing_method</code> parameter</a></dt><dt>1.5. <a href="#id249992">Set <code class="varname">probing_from</code> parameter</a></dt><dt>1.6. <a href="#id250032">Set <code class="varname">probing_reply_codes</code> parameter</a></dt><dt>1.7. <a href="#id250075">Set the <code class="varname">lb_define_blacklist</code> parameter</a></dt><dt>1.8. <a href="#id250186"><code class="function">load_balance</code> usage</a></dt><dt>1.9. <a href="#id250226"><code class="function">lb_disable()</code> usage</a></dt><dt>1.10. <a href="#id250306"><code class="function">lb_is_destination</code> usage</a></dt><dt>1.11. <a href="#id250389"><code class="function">lb_count_count</code> usage</a></dt><dt>1.12. <a href="#id293684"><code class="function">lb_list</code> usage</a></dt><dt>1.13. <a href="#id248890"><code class="function">lb_status</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id280732"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id276486"></a>1.1. Overview</h2></div></div></div><p>
	The Load-Balancer module comes to provide traffic routing based on load. 
	Shortly, when OpenSIPS routes calls to a set of destinations, it is able 
	to keep the load status (as number of ongoing calls) of each destination 
	and to choose to route to the less loaded destination (at that moment). 
	OpenSIPS is aware of the capacity of each destination - it is preconfigured 
	with the maximum load accepted by the destinations. To be more precise, 
	when routing, OpenSIPS will consider the less loaded destination not the 
	destination with the smallest number of ongoing calls, but the destination 
	with the largest available slot.
	</p><p>
	Also the module has the capability to do failover (to try a new destination
	if the selected one done not responde), to keep state of the destinations 
	(to remember the failed destination and avoid using them agai) and to 
	check the health of the destination (by doing probing of the destination 
	and auto re-enabling).
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248311"></a>1.2. How it works</h2></div></div></div><p>
		Please refer to the Load-Balancer tutorial from the OpenSIPS website:
		<a class="ulink" href="http://www.opensips.org/index.php?n=Resources.DocsTutLoadbalancing" target="_top">http://www.opensips.org/index.php?n=Resources.DocsTutLoadbalancing</a>.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248002"></a>1.3. Probing and Disabling destinations</h2></div></div></div><p>
	The module has the capability to monitor the status of the destinations by
	doing SIP probing (sending SIP requests like OPTIONS).
	</p><p>
	For each destination, you can configure what kind of probing should be 
	done (probe_mode column):
	</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>(0)</em></span> - no probing at all;</p></li><li><p><span class="emphasis"><em>(1)</em></span> - probing only when the destination is
		in disabled mode (disabling via MI command will competely stop the 
		probing also). The destination will be automatically re-enabled
		when the probing will succeed next time;</p></li><li><p><span class="emphasis"><em>(2)</em></span> - probing all the time. If disabled, 
		the destination will be automatically re-enabled when the probing 
		will succeed next time;
		</p></li></ul></div><p>
	A destination can become disabled in two ways:
	</p><div class="itemizedlist"><ul type="disc"><li><span class="emphasis"><em>script detection</em></span> - by calling from script the
		lb_disabled() function after try the destination. In this case, if
		probing mode for the destination is (1) or (2), the destination will
		be automatically re-enabled when the probing will succeed.
	</li><li><span class="emphasis"><em>MI command</em></span> - by calling the lb_status MI
		command for disabling (on demand) the destination. If so, the probing
		and re-enabling of this destination will be completly disabled until
		you re-enable it again via MI command - this is designed to allow 
		controlled and complete disabling of some destination during 
		maintenance.
	</li></ul></div><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248970"></a>1.4. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248976"></a>1.4.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>Dialog</em></span> - Dialog module
			</p></li><li><p>
				<span class="emphasis"><em>Dialog</em></span> - TM module (only if probing enabled)
			</p></li><li><p>
				<span class="emphasis"><em>database</em></span> - one of the DB modules
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249019"></a>1.4.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249045"></a>1.5. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249050"></a>1.5.1. <code class="varname">db_url</code> (string)</h3></div></div></div><p>
		The URL pointing to the database where the load-balancing rules 
		are stored.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">mysql://opensips:opensipsrw@localhost/opensips</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249071"></a><p class="title"><b>Example 1.1. Set <code class="varname">db_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("load_balancer", "db_url", "dbdriver://username:password@dbhost/dbname")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249075"></a>1.5.2. <code class="varname">db_table</code> (string)</h3></div></div></div><p>
		The name of the DB table containing the load-balancing rules.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">load_balancer</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249098"></a><p class="title"><b>Example 1.2. Set <code class="varname">db_table</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("load_balancer", "db_table", "lb")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249117"></a>1.5.3. <code class="varname">probing_interval</code> (integer)</h3></div></div></div><p>
		How often (in seconds) the probing of a destination should be done. If
		set to 0, the probing will be disabled as functionality (for all 
		destinations)
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">30</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249140"></a><p class="title"><b>Example 1.3. Set <code class="varname">probing_interval</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("load_balancer", "probing_interval", 60)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249157"></a>1.5.4. <code class="varname">probing_method</code> (string)</h3></div></div></div><p>
		The SIP method to be used for the probing requests.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">"OPTIONS"</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249952"></a><p class="title"><b>Example 1.4. Set <code class="varname">probing_method</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("load_balancer", "probing_method", "INFO")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249969"></a>1.5.5. <code class="varname">probing_from</code> (string)</h3></div></div></div><p>
		The FROM SIP URI to be advertised in the SIP probing requests.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">"sip:prober@localhost"</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249992"></a><p class="title"><b>Example 1.5. Set <code class="varname">probing_from</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("load_balancer", "probing_from", "sip:pinger@192.168.2.10")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250008"></a>1.5.6. <code class="varname">probing_reply_codes</code> (string)</h3></div></div></div><p>
		A comma separted list of SIP reply codes. The codes defined here 
		will be considered as valid reply codes for probing messages,
		apart for 200.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">NULL</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id250032"></a><p class="title"><b>Example 1.6. Set <code class="varname">probing_reply_codes</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("load_balancer", "probing_reply_codes", "501, 403")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250049"></a>1.5.7. <code class="varname">lb_define_blacklist</code> (string)</h3></div></div></div><p>
		Defines a blacklist based on a lb group. This list will contain the IPs
		(no port, all protocols) of the destinations matching the given group.
		</p><p>
		Multiple instances of this param are allowed.
		</p><p>
		<span class="emphasis"><em>
			Default value is &#8220;<span class="quote">NULL</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id250075"></a><p class="title"><b>Example 1.7. Set the <code class="varname">lb_define_blacklist</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("load_balancer", "lb_define_blacklist", "list= 1,4,3")
modparam("load_balancer", "lb_define_blacklist", "blist2= 2,10,6")
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id250095"></a>1.6. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250100"></a>1.6.1. 
		<code class="function">load_balance(grp,resources[,alg])</code>
		</h3></div></div></div><p>
		The function performs load-balancing over the available destinations in
		order to find the less loaded destination that can provide the 
		requested resources and belong to a requested group.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>grp</em></span> - group id for the destinations; the
			destination may be grouped in several groups you can you for 
			differnet scenarios; this can be a number or a variable containing
			a numerical value.
			</p></li><li><p><span class="emphasis"><em>resources</em></span> - string containing a 
			semi-colon list of resources required by the current call.
			</p></li><li><p><span class="emphasis"><em>algorithm</em></span> - algorithm used for 
			computing the available load on the system:
			</p><div class="itemizedlist"><ul type="circle"><li><p><span class="emphasis"><em>0</em></span> - Absolute value - the effective
				available load ( maximum_load - current_load) is used in
				computing the load of each pear/resource.
				</p></li><li><p><span class="emphasis"><em>1</em></span> - Relative value - the relative
				available load (how many percentages are free) is used in
				computing the load of each pear/resource.
				</p></li></ul></div><p>If missing, the default algorithm in 0.
			</p></li></ul></div><p>
		Function returns true is a new destination URI is set pointing to the 
		selected destiantion.
		NOTE that the RURI will not be changed by this function.
		</p><p>
		This function can be used from REQUEST_ROUTE, BRANCH_ROUTE and
		FAILURE_ROUTE.
		</p><div class="example"><a name="id250186"></a><p class="title"><b>Example 1.8. <code class="function">load_balance</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (load_balance("1","trascoding;conference")) {
	# dst URI points to the new destination
	xlog("sending call to $du\n");
	t_relay();
	exit;
}
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250205"></a>1.6.2. 
		<code class="function">lb_disable()</code>
		</h3></div></div></div><p>
		Marks as disabled the last destination that was used for the current
		call. The disabling done via this function will prevent the 
		destination to be used for usage from now on. The probing mechanism
		can re-enable this peer (see the probing section in the begining)
		</p><p>
		This function can be used from REQUEST_ROUTE and FAILURE_ROUTE.
		</p><div class="example"><a name="id250226"></a><p class="title"><b>Example 1.9. <code class="function">lb_disable()</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (t_check_status("(408)|(5[0-9][0-9])")) {
	lb_disable();
	if ( load_balance("1","pstn") ) {
		t_on_failure("1");
		xlog("-----------new dst is $du\n");
		t_relay();
	} else {
		t_reply("500","Error");
	}
}

...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250246"></a>1.6.3. 
		<code class="function">lb_is_destination(ip,port[,group[,active]])</code>
		</h3></div></div></div><p>
		Checks if the given IP and PORT belongs to a destination configured in
		the load-balancer's list. Returns true if found and active (see the
		"active" parameter).
		</p><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE,
		ONREPLY_ROUTE, BRANCH_ROUTE and LOCAL_ROUTE.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>ip</em></span> and <span class="emphasis"><em>port</em></span> - IP 
			and PORT to be checked (any kind of variables are allowed, but
			take care as the PORT variables should have an interger value); 
			A value 0 for the port means "any" - will match any port.
			</p></li><li><p><span class="emphasis"><em>group</em></span> - in what LB group the destination
			should be looked for; If not specified, the search will be in
			all groups.
			</p></li><li><p><span class="emphasis"><em>active</em></span> - if "1", the search will be
			performed only over "active" (not disabled) destinations. If 
			missing, the search will consider any kind of destinations.
			</p></li></ul></div><div class="example"><a name="id250306"></a><p class="title"><b>Example 1.10. <code class="function">lb_is_destination</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (lb_is_destination("$si","$sp") ) {
	# request from a LB destination
}
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250325"></a>1.6.4. 
		<code class="function">lb_count_call(ip,port,grp,resources)</code>
		</h3></div></div></div><p>
		The function counts the current call as load for a given destination 
		with some given resources. Note that this call is not going through
		the load-balancing logic (there are not routing decision taken for the
		call); it is simply counted by LB as ongoing call for a destination;
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>ip</em></span> and <span class="emphasis"><em>port</em></span> - IP 
			and PORT to identify the destination the call has to be counted
			for.
			</p></li><li><p><span class="emphasis"><em>grp</em></span> - group id for the destinations; if
			no knows, "-1" will mean all groups.
			</p></li><li><p><span class="emphasis"><em>resources</em></span> - string containing a 
			semi-colon list of resources required by the current call.
			</p></li></ul></div><p>
		Function returns true if the call was properly taken into consideration
		for estimating the load on the destination.
		</p><p>
		This function can be used from REQUEST_ROUTE, BRANCH_ROUTE and
		FAILURE_ROUTE.
		</p><div class="example"><a name="id250389"></a><p class="title"><b>Example 1.11. <code class="function">lb_count_count</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# count as load also the calls orgininated by lb destinations
if (lb_is_destination("$si","$sp") ) {
	# inbound call from destination
	lb_count_count("$si","$sp","-1","conference");
} else {
	# outbound call to destinations
	if ( !load_balance("1","conference") ) {
		send_reply("503","unavailable");
		exit();
	}
	# dst URI points to the new destination
	xlog("sending call to $du\n");
	t_relay();
	exit;
}
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id250411"></a>1.7. Exported statistics</h2></div></div></div><p>
	NONE
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id250421"></a>1.8. Exported MI Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250427"></a>1.8.1. <code class="varname">lb_reload</code></h3></div></div></div><p>
		Trigers the reload of the load balancing data from the DB.
		</p><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
		:lb_reload:_reply_fifo_file_
		_empty_line_
		</pre></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250447"></a>1.8.2. <code class="varname">lb_resize</code></h3></div></div></div><p>
		Changes the capacity for a resource of a destination. The function 
		receives as parameters the ID (as per DB) of the destination along 
		with the name of the resource you want to resize.
		</p><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
		:lb_resize:_reply_fifo_file_
		11   /*dstination id*/
		voicemail  /*resource name*/
		56   /* new resource capacity*/
		_empty_line_
		</pre></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250470"></a>1.8.3. <code class="varname">lb_list</code></h3></div></div></div><p>
		Lists all the destinations and the maximum and current load for each 
		resource of the destination.
		</p><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
		:lb_list:_reply_fifo_file_
		_empty_line_
		</pre><div class="example"><a name="id293684"></a><p class="title"><b>Example 1.12. <code class="function">lb_list</code> usage</b></p><div class="example-contents"><pre class="programlisting">
$ ./opensipsctl fifo lb_list
Destination:: sip:127.0.0.1:5100 id=1 enabled=yes auto-re=on
        Resource:: pstn max=3 load=0
        Resource:: transc max=5 load=1
        Resource:: vm max=5 load=2
Destination:: sip:127.0.0.1:5200 id=2 enabled=no auto-re=on
        Resource:: pstn max=6 load=0
        Resource:: trans max=57 load=0
        Resource:: vm max=5 load=0
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248867"></a>1.8.4. <code class="varname">lb_status</code></h3></div></div></div><p>
		Gets or sets the status (enabled or disabled) of a destination. The 
		function takes 2 parameters, first mandatory, the id of the destiantion
		and second, optional, the new status. If no new status is given, the
		function will return the current status. If a new status is given 
		(0 - disable, 1 - enable), this status will be forced for the 
		destination.
		</p><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
		:lb_status:_reply_fifo_file_
		id
		status (optional)
		_empty_line_
		</pre><div class="example"><a name="id248890"></a><p class="title"><b>Example 1.13. <code class="function">lb_status</code> usage</b></p><div class="example-contents"><pre class="programlisting">
$ ./opensipsctl fifo lb_status 2
enable:: no
$ ./opensipsctl fifo lb_status 2 1
$ ./opensipsctl fifo lb_status 2
enable:: yes
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248910"></a>1.9. Exported pseudo-variables</h2></div></div></div><p>
	NONE
	</p></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id294728"></a>Chapter 2. Developer Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id294733"></a>2.1. Available Functions</h2></div></div></div><p>NONE</p></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id294696"></a>Chapter 3. Frequently Asked Questions</h2></div></div></div><div class="qandaset"><table border="0" summary="Q and A Set"><col align="left" width="1%"><tbody><tr class="question"><td align="left" valign="top"><a name="id294700"></a><a name="id294718"></a><p><b>3.1.</b></p></td><td align="left" valign="top"><p>Where can I find more about OpenSIPS?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Take a look at <a class="ulink" href="http://www.opensips.org/" target="_top">http://www.opensips.org/</a>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294812"></a><a name="id294449"></a><p><b>3.2.</b></p></td><td align="left" valign="top"><p>Where can I post a question about this module?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			First at all check if your question was already answered on one of
			our mailing lists: 
		</p><div class="itemizedlist"><ul type="disc"><li><p>User Mailing List - <a class="ulink" href="http://lists.opensips.org/cgi-bin/mailman/listinfo/users" target="_top">http://lists.opensips.org/cgi-bin/mailman/listinfo/users</a></p></li><li><p>Developer Mailing List - <a class="ulink" href="http://lists.opensips.org/cgi-bin/mailman/listinfo/devel" target="_top">http://lists.opensips.org/cgi-bin/mailman/listinfo/devel</a></p></li></ul></div><p>
			E-mails regarding any stable OpenSIPS release should be sent to 
			<code class="email">&lt;<a class="email" href="mailto:users@lists.opensips.org">users@lists.opensips.org</a>&gt;</code> and e-mails regarding development versions
			should be sent to <code class="email">&lt;<a class="email" href="mailto:devel@lists.opensips.org">devel@lists.opensips.org</a>&gt;</code>.
		</p><p>
			If you want to keep the mail private, send it to 
			<code class="email">&lt;<a class="email" href="mailto:users@lists.opensips.org">users@lists.opensips.org</a>&gt;</code>.
		</p></td></tr><tr class="question"><td align="left" valign="top"><a name="id294853"></a><a name="id294855"></a><p><b>3.3.</b></p></td><td align="left" valign="top"><p>How can I report a bug?</p></td></tr><tr class="answer"><td align="left" valign="top"></td><td align="left" valign="top"><p>
			Please follow the guidelines provided at:
			<a class="ulink" href="https://github.com/OpenSIPS/opensips/issues" target="_top">https://github.com/OpenSIPS/opensips/issues</a>.
		</p></td></tr></tbody></table></div></div></div></body></html>
