<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Presence_CallInfo Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id247984"></a>Presence_CallInfo Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3><code class="email">&lt;<a class="email" href="mailto:osas@voipembedded.com">osas@voipembedded.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3><code class="email">&lt;<a class="email" href="mailto:osas@voipembedded.com">osas@voipembedded.com</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2010 
		<a class="ulink" href="http://www.voipembedded.com" target="_top">VoIP Embedded, Inc.</a>
	    </p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 7754 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id281748">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id293636">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248964">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248969">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248992">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249004">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249009">1.3.1. <code class="varname">call_info_timeout_notification</code> (int)</a></span></dt><dt><span class="section"><a href="#id249046">1.3.2. <code class="varname">line_seize_timeout_notification</code> (int)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249084">1.4. Exported Functions</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249029">Set <code class="varname">call_info_timeout_notification</code> parameter</a></dt><dt>1.2. <a href="#id249066">Set <code class="varname">line_seize_timeout_notification</code> parameter</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id281748"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293636"></a>1.1. Overview</h2></div></div></div><p> 
	      The module enables the handling of "call-info" and "line-seize"
	      events inside the presence module.
	      It is used with the general event handling module: presence and
	      it constructs and adds "Call-Info" headers to notification events.
	      To send "call-info" notification to watchers, a third-party
	      application must publish "call-info" events to the presence server.
	    </p><p>
 	      The module does not currently implement any authorization
	      rules.  It assumes that publish requests are only issued by
	      a third-party application and subscribe requests only by
	      subscriber to call-info and line-seize events.  Authorization
	      can thus be easily done by OpenSIPS configuration file before
	      calling handle_publish() and handle_subscribe() functions.
	    </p><p>
	      The module implements a simple check for the presence of
	      Call-Info headers in received PUBLISH requests.
	    </p><p>
	      To get better understanding on how the module works please take a
	      look at the follwing figure:
	</p><pre class="programlisting">

   caller       proxy &amp;   callee        watcher        publisher
alice@example  presence  bob@example  watcher@example
                 server                       
     |             |           |           |              |
     |             |&lt;-----SUBSCRIBE bob----|              |
     |             |------200 OK----------&gt;|              |
     |             |------NOTIFY----------&gt;|              |
     |             |&lt;-----200 OK-----------|              |
     |             |           |           |              |
     |--INV bob---&gt;|           |           |              |
     |             |--INV bob-&gt;|           |              |
     |             |&lt;-100------|           |              |
     |             |&lt;-----PUBLISH(alerting)---------------|
     |             |------200 OK-------------------------&gt;|
     |             |------NOTIFY----------&gt;|              |
     |             |&lt;-----200 OK-----------|              |
     |             |           |           |              |
     |             |&lt;-180 ring-|           |              |
     |&lt;--180 ring--|           |           |              |
     |             |           |           |              |
     |             |           |           |              |
     |             |&lt;-200 OK---|           |              |
     |&lt;--200 OK----|           |           |              |
     |             |&lt;-----PUBLISH(active)-----------------|
     |             |------200 OK-------------------------&gt;|
     |             |------NOTIFY----------&gt;|              |
     |             |&lt;-----200 OK-----------|              |
     |             |           |           |              |

	</pre><p>
	</p><div class="itemizedlist"><ul type="disc"><li><p>
		The watcher subscribes the "Event: dialog" of Bob.
	    </p></li><li><p>
		Alice calls Bob.
	    </p></li><li><p>
		The publisher is publishing the "alerting" state for Bob.
	    </p></li><li><p>
		PUBLISH is received and handled by presence module.
		Presence module updates the "presentity".
		Presence module checks for active watchers of the presentity.
		The active watcher is notified via a NOTIFY SIP request.
	    </p></li><li><p>
		Bob answers the call.
	    </p></li><li><p>
		The publisher is publishing the "active" state for Bob.
	    </p></li><li><p>
		PUBLISH is received and handled by presence module.
		Presence module updates the "presentity".
		Presence module checks for active watchers of the presentity.
		The active watcher is notified via a NOTIFY SIP request.
	    </p></li></ul></div><p>
	    </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248964"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248969"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>presence</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248992"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		None.
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249004"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249009"></a>1.3.1. <code class="varname">call_info_timeout_notification</code> (int)</h3></div></div></div><p>
		Enables or disables call_info event timeout notifications.
		</p><p><span class="emphasis"><em>Default value is &#8220;<span class="quote">1</span>&#8221;</em></span> (enabled).</p><div class="example"><a name="id249029"></a><p class="title"><b>Example 1.1. Set <code class="varname">call_info_timeout_notification</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("presence_callinfo", "call_info_timeout_notification", 0)
...
		</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249046"></a>1.3.2. <code class="varname">line_seize_timeout_notification</code> (int)</h3></div></div></div><p>
		Enables or disables line_seize event timeout notifications.
		</p><p><span class="emphasis"><em>Default value is &#8220;<span class="quote">0</span>&#8221;</em></span> (disabled).</p><div class="example"><a name="id249066"></a><p class="title"><b>Example 1.2. Set <code class="varname">line_seize_timeout_notification</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("presence_callinfo", "line_seize_timeout_notification", 1)
...
		</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249084"></a>1.4. Exported Functions</h2></div></div></div><p>
	        None to be used in configuration file.
	      </p></div></div></div></body></html>
