<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>presence_dialoginfo Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id247987"></a>presence_dialoginfo Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Juha</span> <span class="surname">Heinanen</span></h3><code class="email">&lt;<a class="email" href="mailto:jh@tutpro.com">jh@tutpro.com</a>&gt;</code></div><span class="firstname">Klaus<br></span><span class="surname">Darilion<br></span><code class="email">&lt;<a class="email" href="mailto:klaus.darilion@mailinglists@pernau.at">klaus.darilion@mailinglists@pernau.at</a>&gt;</code><div class="author"><h3 class="author"></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Juha</span> <span class="surname">Heinanen</span></h3><code class="email">&lt;<a class="email" href="mailto:jh@tutpro.com">jh@tutpro.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Klaus</span> <span class="surname">Darilion</span></h3><code class="email">&lt;<a class="email" href="mailto:klaus.darilion@mailinglists@pernau.at">klaus.darilion@mailinglists@pernau.at</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2007 Juha Heinanen</p></div><div><p class="copyright">Copyright © 2008 Klaus Darilion, IPCom (Module implementation was partly sponsored by Silver Server (www.sil.at))</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id248318">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id248334">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id249039">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249045">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249068">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249079">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249085">1.3.1. <code class="varname">force_single_dialog</code> (int)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249138">1.4. Exported Functions</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249121">Set <code class="varname"></code> parameter</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id248318"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248334"></a>1.1. Overview</h2></div></div></div><p> 
	      The module enables the handling of "Event: dialog" (as defined 
	      in RFC 4235) inside of the presence module. This can be used
	      distribute the dialog-info status to the subscribed watchers.
	    </p><p>
 	      The module does not currently implement any authorization
	      rules.  It assumes that publish requests are only issued by
	      an authorized application and subscribe requests only by
	      authorized users.  Authorization can thus be easily done in 
	      OpenSIPS configuration file before calling handle_publish() 
	      and handle_subscribe() functions.
	    </p><p>
	      Note: This module only activates the processing of the "dialog" 
	      in the presence module. To send dialog-info to watchers you also 
	      need a source which PUBLISH the dialog info to the presence module.
	      For example you can use the pua_dialoginfo module or any external
	      component. This approach allows to have the presence server and the
	      dialog-info aware publisher (e.g. the main proxy) on different 
	      OpenSIPS instances.
	    </p><p>
			This module by default does body aggregation. That means, if the presence 
			module received PUBLISH from multiple presentities (e.g. if the entity has
			multiple dialogs the pua_dialoginfo will send multiple PUBLISH), the
			module will parse all the received (and still valid, depending on the Expires 
			header in the PUBLISH request) XML documents and generate a single 
			XML document with multiple "dialog" elements. This is perfectly valid, but
			unfortunately not supported by all SIP phones, e.g. Linksys SPA962 crashes
			when it receives dialog-info with multiple dialog elements. In this case use
			the force_single_dialog module parameter.
	    </p><p>
			To get better understanding how all the module works together please take a
			look at the follwing figure:
        </p><pre class="programlisting">


    Main Proxy and Presence Server on the same Instance

   caller        proxy &amp;      callee         watcher
alice@example   presence   bob@example   watcher@example
                 server
     |             |            |               |
     |             |&lt;-------SUBSCRIBE bob-------|
     |             |--------200 OK-------------&gt;|
     |             |--------NOTIFY-------------&gt;|
     |             |&lt;-------200 OK--------------|
     |             |            |               |
     |--INV bob---&gt;|            |               |
     |             |--INV bob--&gt;|               |
     |             |&lt;-100-------|               |
     |             |            |               |
     |             |&lt;-180 ring--|               |
     |&lt;--180 ring--|            |               |
     |             |--          |               |
     |             |   \        |               |
     |             | PUBLISH bob|               |
     |             |   /        |               |
     |             |&lt;-          |               |
     |             |            |               |
     |             |--          |               |
     |             |   \        |               |
     |             | 200 ok     |               |
     |             |   /        |               |
     |             |&lt;-          |               |
     |             |--------NOTIFY-------------&gt;|
     |             |&lt;-------200 OK--------------|
     |             |            |               |

</pre><p>

			</p><div class="itemizedlist"><ul type="disc"><li><p>
					The watcher subscribes the "Event: dialog" of Bob.
				</p></li><li><p>
					Alice calls Bob.
				</p></li><li><p>
					Bob replies with ringing, the dialog in the dialog module
					transits to "early". The callback in pua_dialoginfo is executed.
					The pua_dialoginfo module creates the XML document and uses the
					pua module to send the PUBLISH. (pua module itself uses tm module
					to send the PUBLISH stateful)
				</p></li><li><p>
					PUBLISH is received and handled by presence module. Presence
					module updates the "presentity". Presence module checks for active watchers
					of the presentity. It gives all the XML dcouments to presence_dialoginfo
					module to aggregate them into a single XML document. Then it sends the 
					NOTIFY with the aggregated XML document to all active watchers.
				</p></li></ul></div><p>

			The presence server can also be separated from the main proxy by using a separate 
			OpenSIPS instance as shown in the following figure. (Either set the outbound_proxy
			parameter of pua module or make sure to route the "looped" PUBLISH requests from the 
			main proxy to the presence server).

        </p><pre class="programlisting">


    Main Proxy and Presence Server use a separate Instance

   caller        proxy &amp;   presence      callee         watcher
alice@example    server     server     bob@example   watcher@example
     |             |            |               |            |
     |             |&lt;--------------------SUBSCRIBE bob-------|
     |             |-SUBSC bob-&gt;|               |            |
     |             |&lt;-200 ok----|               |            |
     |             |---------------------200 OK-------------&gt;|
     |             |          .... NOTIFY ... 200 OK ...     |
     |             |            |               |            |
     |             |            |               |            |
     |--INV bob---&gt;|            |               |            |
     |             |--INV bob------------------&gt;|            |
     |             |&lt;-100-----------------------|            |
     |             |            |               |            |
     |             |&lt;-180 ring------------------|            |
     |&lt;--180 ring--|            |               |            |
     |             |--PUBL bob-&gt;|               |            |
     |             |&lt;-200 ok----|               |            |
     |             |            |--------NOTIFY-------------&gt;|
     |             |            |&lt;-------200 OK--------------|
     |             |            |               |            |



</pre><p>

	    </p><p>
			Known issues:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
					The "version" attribute is increased for every NOTIFY, even 
					if the XML document has not changed. This is of course valid,
					but not very smart.
				</p></li></ul></div><p>



	    </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249039"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249045"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>presence</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249068"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		None.
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249079"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249085"></a>1.3.1. <code class="varname">force_single_dialog</code> (int)</h3></div></div></div><p>
			By default the module aggregates all available dialog info
			into a single dialog-info document containing multiple
			"dialog" elements. If the phone does not support this, you
			can activate this parameter.
		</p><p>
			If this parameter is set, only the dialog element with the
			currently most interesting dialog state will be put into the 
			dialog-info document. Thus, the dialog-info element will contain
			only a single "dialog" element. The algorithm chooses the state
			based onf the following order of priority (least important first):
			terminated, trying, proceeding, confirmed, early. Note: I consider
			the "early" state more intersting than confirmed as often you might
			want to pickup a call if the originall callee is already busy in a 
			call.
		</p><p>
			<span class="emphasis"><em>Default value is &#8220;<span class="quote">0</span>&#8221;.</em></span>
		</p><div class="example"><a name="id249121"></a><p class="title"><b>Example 1.1. Set <code class="varname"></code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("presence_dialoginfo", "force_single_dialog", 1)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249138"></a>1.4. Exported Functions</h2></div></div></div><p>
			None to be used in configuration file.
		</p></div></div></div></body></html>
