<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Presence User Agent Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id248507"></a>Presence User Agent Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Anca-Maria</span> <span class="surname">Vamanu</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Anca-Maria</span> <span class="surname">Vamanu</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Saul</span> <span class="surname">Ibarra Corretge</span></h3></div></div></div><div><p class="copyright">Copyright © 2006 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 9371 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id277807">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id248328">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248316">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248321">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248033">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248953">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248958">1.3.1. <code class="varname">hash_size</code> (int)</a></span></dt><dt><span class="section"><a href="#id249002">1.3.2. <code class="varname">db_url</code> (str)</a></span></dt><dt><span class="section"><a href="#id249051">1.3.3. <code class="varname">db_table</code> (str)</a></span></dt><dt><span class="section"><a href="#id249083">1.3.4. <code class="varname">min_expires</code> (int)</a></span></dt><dt><span class="section"><a href="#id249121">1.3.5. <code class="varname">default_expires</code> (int)</a></span></dt><dt><span class="section"><a href="#id249160">1.3.6. <code class="varname">update_period</code> (int)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249958">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id249963">1.4.1. 
		<code class="function">pua_update_contact()</code>
		</a></span></dt></dl></dd><dt><span class="section"><a href="#id250034">1.5. Installation</a></span></dt></dl></dd><dt><span class="chapter"><a href="#id250229">2. Developer Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id250236">2.1. 
				<code class="function">bind_pua(pua_api_t* api)</code>
				</a></span></dt><dt><span class="section"><a href="#id293772">2.2. 
			<code class="function">send_publish</code>
		</a></span></dt><dt><span class="section"><a href="#id293828">2.3. 
			<code class="function">send_subscribe</code>
		</a></span></dt><dt><span class="section"><a href="#id293883">2.4. 
			<code class="function">is_dialog</code>
		</a></span></dt><dt><span class="section"><a href="#id293925">2.5. 
			<code class="function">register_puacb</code>
		</a></span></dt><dt><span class="section"><a href="#id293972">2.6. 
			<code class="function">add_event</code>
		</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248981">Set <code class="varname">hash_size</code> parameter</a></dt><dt>1.2. <a href="#id249024">Set <code class="varname">db_url</code> parameter</a></dt><dt>1.3. <a href="#id249066">Set <code class="varname">db_table</code> parameter</a></dt><dt>1.4. <a href="#id249104">Set <code class="varname">min_expires</code> parameter</a></dt><dt>1.5. <a href="#id249143">Set <code class="varname">default_expires</code> parameter</a></dt><dt>1.6. <a href="#id249182">Set <code class="varname">update_period</code> parameter</a></dt><dt>1.7. <a href="#id250015"><code class="function">pua_update_contact</code> usage</a></dt><dt>2.1. <a href="#id293753"><code class="function">pua_api</code> structure</a></dt><dt>2.2. <a href="#id293906"><code class="function">pua_is_dialog </code>usage example</a></dt><dt>2.3. <a href="#id293952"><code class="function">register_puacb </code>usage example</a></dt><dt>2.4. <a href="#id294015"><code class="function">add_event </code>usage example</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id277807"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248328"></a>1.1. Overview</h2></div></div></div><p>
		This module offer the functionality of a presence user agent client,
		sending Subscribe and Publish messages. 
	</p><p>
		 Now it can be used with the following modules: pua_mi and pua_usrloc,
		 pua_bla and pua_xmpp.
		 The pua_mi offer the possibility to publish any kind of information
		 or subscribing to a resource through fifo. The pua_usrloc module calls
		 a function exported by pua modules to publish elementary presence
		 information, such as basic status "open" or "closed", for clients that
		 do not implement client-to-server presence.
		 Through pua_bla , BRIDGED LINE APPEARANCE features are added to OpenSIPs.
		 The pua_xmpp module represents a gateway between SIP and XMPP, so that 
		 jabber and SIP clients can exchange presence information. 
	</p><p>
		The module use cache to store presentity list and writes to database
		on timer to be able to recover upon restart.
	</p><p>
		Notice: This module must not be used in no fork mode (the locking mechanism
		used may cause deadlock in no fork mode).
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248316"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248321"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>a database modules</em></span>.
			</p></li><li><p>
				<span class="emphasis"><em>tm</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248033"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>libxml</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248953"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248958"></a>1.3.1. <code class="varname">hash_size</code> (int)</h3></div></div></div><p>
		The size of the hash table used for storing Subscribe and 
		Publish information. 
        This parameter will be used as the power of 2 when computing table size.
        </p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">9</span>&#8221;.	
		</em></span>
		</p><div class="example"><a name="id248981"></a><p class="title"><b>Example 1.1. Set <code class="varname">hash_size</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pua", "hash_size", 11)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249002"></a>1.3.2. <code class="varname">db_url</code> (str)</h3></div></div></div><p>
		Database url.
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">&gt;mysql://opensips:opensipsrw@localhost/opensips</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249024"></a><p class="title"><b>Example 1.2. Set <code class="varname">db_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pua", "db_url" "dbdriver://username:password@dbhost/dbname")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249051"></a>1.3.3. <code class="varname">db_table</code> (str)</h3></div></div></div><p>
		The name of the database table.
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">pua</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249066"></a><p class="title"><b>Example 1.3. Set <code class="varname">db_table</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pua", "db_table", "pua")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249083"></a>1.3.4. <code class="varname">min_expires</code> (int)</h3></div></div></div><p>
		The inferior expires limit for both Publish and Subscribe.
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">300</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249104"></a><p class="title"><b>Example 1.4. Set <code class="varname">min_expires</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pua", "min_expires", 0)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249121"></a>1.3.5. <code class="varname">default_expires</code> (int)</h3></div></div></div><p>
		The default expires value used in case this information is not provisioned.
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">3600</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249143"></a><p class="title"><b>Example 1.5. Set <code class="varname">default_expires</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pua", "default_expires", 3600)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249160"></a>1.3.6. <code class="varname">update_period</code> (int)</h3></div></div></div><p>
		The interval at which the information in database and hash table
		should be updated. In the case of the hash table updating is 
		deleting expired messages.
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">30</span>&#8221;.
		</em></span>
		</p><div class="example"><a name="id249182"></a><p class="title"><b>Example 1.6. Set <code class="varname">update_period</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pua", "update_period", 100)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249958"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249963"></a>1.4.1. 
		<code class="function">pua_update_contact()</code>
		</h3></div></div></div><p>
		The remote target can be updated by the Contact of a subsequent in
		dialog request. In the PUA watcher case (sending a SUBSCRIBE messages),
		this means that the remote target for the following Subscribe messages
		can be updated at any time by the contact of a Notify message. 
		If this function is called on request route on receiving a Notify
		message, it will try to update the stored remote target.
		</p><p>
		This function can be used from REQUEST_ROUTE.
		</p><p>
		<span class="emphasis"><em>Return code:</em></span>
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em> 1 - if success</em></span>.
			</p></li><li><p>
				<span class="emphasis"><em> -1 - if error</em></span>.
			</p></li></ul></div><p>
		</p><div class="example"><a name="id250015"></a><p class="title"><b>Example 1.7. <code class="function">pua_update_contact</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if(method=="NOTIFY")
    pua_update_contact();
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id250034"></a>1.5. Installation</h2></div></div></div><p>
	The module requires 1 table in OpenSIPS database: pua. The SQL 
	syntax to create it can be found in presence_xml-create.sql     
	script in the database directories in the opensips/scripts folder.
	You can also find the complete database documentation on the
	project webpage, <a class="ulink" href="http://www.opensips.org/html/docs/db/db-schema-devel.html" target="_top">http://www.opensips.org/html/docs/db/db-schema-devel.html</a>.
	</p></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id250229"></a>Chapter 2. Developer Guide</h2></div></div></div><p>
		The module provides the following functions that can be used
		in other OpenSIPS modules.
	</p><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id250236"></a>2.1. 
				<code class="function">bind_pua(pua_api_t* api)</code>
				</h2></div></div></div><p>
				This function binds the pua modules and fills the structure 
				with the two exported function.
			</p><div class="example"><a name="id293753"></a><p class="title"><b>Example 2.1. <code class="function">pua_api</code> structure</b></p><div class="example-contents"><pre class="programlisting">
...
typedef struct pua_api {
	send_subscribe_t send_subscribe;
	send_publish_t send_publish;
	query_dialog_t is_dialog;
	register_puacb_t register_puacb;
	add_pua_event_t add_event;
} pua_api_t;
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293772"></a>2.2. 
			<code class="function">send_publish</code>
		</h2></div></div></div><p>
			Field type:
				</p><pre class="programlisting">
...
typedef int (*send_publish_t)(publ_info_t* publ);
...
				</pre><p>
		</p><p>
		    This function receives as a parameter a structure with Publish 
			required information and sends a Publish message.
		</p><p>
		The structure received as a parameter:
		</p><pre class="programlisting">
...
typedef struct publ_info

  str id;             /*  (optional )a value unique for one combination
                          of pres_uri and flag */
  str* pres_uri;      /*  the presentity uri */	
  str* body;          /*  the body of the Publish message; 
                          can be NULL in case of an update expires*/ 	
  int  expires;       /*  the expires value that will be used in
                          Publish Expires header*/	
  int flag;           /*  it can be : INSERT_TYPE or UPDATE_TYPE
                          if missing it will be established according 
                          to the result of the search in hash table*/ 	
  int source_flag;    /*  flag identifying the resource ;
                          supported values: UL_PUBLISH, MI_PUBLISH,
                          BLA_PUBLISH, XMPP_PUBLISH*/
  int event;          /*  the event flag;
                          supported values: PRESENCE_EVENT, BLA_EVENT,
                          MWI_EVENT */
  str content_type;   /*  the content_type of the body if present
                          (optional if the same as the default value
                          for that event)*/
  str* etag;          /*  (optional) the value of the etag the request
                          should match */
  str* extra_headers  /*  (optional) extra_headers that should be added
                          to Publish msg*/
  publrpl_cb_t* cbrpl;/*  callback function to be called when receiving
                          the reply for the sent request */
  void* cbparam;      /*  extra parameter for tha callback function */

  str outbound_proxy; /*  the outbound proxy to be used when sending
							the Publish request*/

}publ_info_t;
...
		</pre><p>
			The callback function type:
						</p><pre class="programlisting">
...
typedef int (publrpl_cb_t)(struct sip_msg* reply, void*  extra_param);
...
		</pre><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293828"></a>2.3. 
			<code class="function">send_subscribe</code>
		</h2></div></div></div><p>
			Field type:
				</p><pre class="programlisting">
...
typedef int (*send_subscribe_t)(subs_info_t* subs);
...
</pre><p>
		</p><p>
			This function receives as a parameter a structure with Subscribe 
			required information and sends a Subscribe message.
		</p><p>
			The structure received as a parameter:
			</p><pre class="programlisting">
...
typedef struct subs_info

  str id;              /*  an id value unique for one combination
                           of pres_uri and flag */
  str* pres_uri;       /*  the presentity uri */	
  str* watcher_uri;    /*  the watcher uri */
  str* contact;        /*  the uri that will be used in
                           Contact header*/  
  str* remote_target;  /*  the uri that will be used as R-URI
                           for the Subscribe message(not compulsory;
                           if not set the value of the pres_uri field
                           is used) */
  str* outbound_proxy; /*  the outbound_proxy to use when sending the 
                           Subscribe request*/
  int event;           /*  the event flag; supported value: 
                           PRESENCE_EVENT, BLA_EVENT, PWINFO_EVENT*/ 
  int expires;         /*  the expires value that will be used in
                           Subscribe Expires header */	
  int flag;            /*  it can be : INSERT_TYPE or UPDATE_TYPE
                           not compulsory */	
  int source_flag;     /*  flag identifying the resource ;
                           supported values:  MI_SUBSCRIBE, 
                           BLA_SUBSCRIBE, XMPP_SUBSCRIBE,
                           XMPP_INITIAL_SUBS */
}subs_info_t;
...
</pre><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293883"></a>2.4. 
			<code class="function">is_dialog</code>
		</h2></div></div></div><p>
			Field type:
				</p><pre class="programlisting">
...
typedef int  (*query_dialog_t)(ua_pres_t* presentity);
...
				</pre><p>
		</p><p>
			This function checks is the parameter corresponds to a stored
			Subscribe initiated dialog. 
		</p><div class="example"><a name="id293906"></a><p class="title"><b>Example 2.2. <code class="function">pua_is_dialog </code>usage example</b></p><div class="example-contents"><pre class="programlisting">
...	
	if(pua_is_dialog(dialog) &lt; 0)
	{
		LM_ERR("querying dialog\n");
		goto error;
	}
...	
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293925"></a>2.5. 
			<code class="function">register_puacb</code>
		</h2></div></div></div><p>
			Field type:
				</p><pre class="programlisting">
...
typedef int (*register_puacb_t)(int types, pua_cb f, void* param );
...
				</pre><p>
		</p><p>
			This function registers a callback to be called on receiving the reply message
			for a sent Subscribe request.
			The type parameter should be set the same as the source_flag for that request.
			The function registered as callback for pua should be of type pua_cb , which is:
			typedef void (pua_cb)(ua_pres_t* hentity, struct msg_start * fl);
			The parameters are the dialog structure for that request and the first line of the
			reply message.
		</p><div class="example"><a name="id293952"></a><p class="title"><b>Example 2.3. <code class="function">register_puacb </code>usage example</b></p><div class="example-contents"><pre class="programlisting">
...
	if(pua.register_puacb(XMPP_SUBSCRIBE, Sipreply2Xmpp, NULL) &amp; 0)
	{
		LM_ERR("Could not register callback\n");
		return -1;
	}
...	
	</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293972"></a>2.6. 
			<code class="function">add_event</code>
		</h2></div></div></div><p>
			Field type:
				</p><pre class="programlisting">
...
typedef int (*add_pua_event_t)(int ev_flag, char* name, 
   char* content_type,evs_process_body_t* process_body);

- ev_flag     : an event flag defined as a macro in pua module		
- name        : the event name to be used in Event request headers
- content_type: the default content_type for Publish body for 
                that event (NULL if winfo event)
- process_body: function that processes the received body before 
                using it to construct the PUBLISH request
                (NULL if winfo event)
...
				</pre><p>
		</p><p>
			This function allows registering new events to the pua module.
			Now there are 4 events supported by the pua module: presence, 
			presence;winfo, message-summary, dialog;sla. These events are registered
			from within the pua module.
        </p><p>
			Filed type for process_body: 
				</p><pre class="programlisting">
...
typedef int (evs_process_body_t)(struct publ_info* publ, 
  str** final_body, int ver, str* tuple);
- publ      : the structure received as a parameter in send_publish 
              function ( initial body found in publ-&gt;body)
- final_body: the pointer where the result(final_body) should be stored 
- ver       : a counter for the sent Publish requests
              (used for winfo events)
- tuple     : a unique identifier for the resource;
              if an initial Publish it should be returned as a result
              and it will be stored  for that record, otherwise it will
              be given as a parameter;    
...
				</pre><p>
		</p><div class="example"><a name="id294015"></a><p class="title"><b>Example 2.4. <code class="function">add_event </code>usage example</b></p><div class="example-contents"><pre class="programlisting">
...
	if(pua.add_event((PRESENCE_EVENT, "presence", "application/pidf+xml", 
				pres_process_body) &amp; 0)
	{
		LM_ERR("Could not register new event\n");
		return -1;
	}
...	
	</pre></div></div><br class="example-break"></div></div></div></body></html>
