<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>PUA Usrloc</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id247984"></a>PUA Usrloc</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Anca-Maria</span> <span class="surname">Vamanu</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Anca-Maria</span> <span class="surname">Vamanu</span></h3></div></div></div><div><p class="copyright">Copyright © 2006 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id274823">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id276434">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id269557">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id270749">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248001">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248026">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248032">1.3.1. <code class="varname">default_domain</code> (str)</a></span></dt><dt><span class="section"><a href="#id248967">1.3.2. <code class="varname">entity_prefix</code> (str)</a></span></dt><dt><span class="section"><a href="#id249007">1.3.3. <code class="varname">presence_server</code> (str)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249038">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id249043">1.4.1. 
				<code class="function">pua_set_publish()</code>
				</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248948">Set <code class="varname">default_domain</code> parameter</a></dt><dt>1.2. <a href="#id248990">Set <code class="varname">presentity_prefix</code> parameter</a></dt><dt>1.3. <a href="#id249020">Set <code class="varname">presence_server</code> parameter</a></dt><dt>1.4. <a href="#id249062"><code class="function">pua_set_publish</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id274823"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id276434"></a>1.1. Overview</h2></div></div></div><p>
		 The pua_usrloc is the connector between usrloc and pua modules.
		 It creates the environment to send PUBLISH requests for user
		 location records, on specific events (e.g., when new record is
		 added in usrloc, a PUBLISH with status open (online) is issued;
		 when expires, it sends closed (offline)).
	</p><p>
		Using this module, phones which have no support for presence can
		be seen as online/offline. 
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id269557"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id270749"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>usrloc</em></span>.
			</p></li><li><p>
				<span class="emphasis"><em>pua</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248001"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>libxml</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248026"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248032"></a>1.3.1. <code class="varname">default_domain</code> (str)</h3></div></div></div><p>
		The default domain to use when constructing the presentity
		uri if it is missing from recorded aor. 
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">NULL</span>&#8221;.	
		</em></span>
		</p><div class="example"><a name="id248948"></a><p class="title"><b>Example 1.1. Set <code class="varname">default_domain</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pua_usrloc", "default_domain", "opensips.org")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248967"></a>1.3.2. <code class="varname">entity_prefix</code> (str)</h3></div></div></div><p>
		The prefix when construstructing entity attribute to be added to
		presence node in xml pidf.
		(ex: pres:user@domain ).
		</p><p>
		<span class="emphasis"><em>Default value is &#8220;<span class="quote">NULL</span>&#8221;.	
		</em></span>
		</p><div class="example"><a name="id248990"></a><p class="title"><b>Example 1.2. Set <code class="varname">presentity_prefix</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pua_usrloc", "entity_prefix", "pres")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249007"></a>1.3.3. <code class="varname">presence_server</code> (str)</h3></div></div></div><p>
		The the address of the presence server. If set, it will be
		used as outbound proxy when sending PUBLISH requests.
		</p><div class="example"><a name="id249020"></a><p class="title"><b>Example 1.3. Set <code class="varname">presence_server</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pua_usrloc", "presence_server", "sip:pa@opensips.org:5075")
...
	</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249038"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249043"></a>1.4.1. 
				<code class="function">pua_set_publish()</code>
				</h3></div></div></div><p>
				The function is used to mark REGISTER requests that have to
				issue a PUBLISH. The PUBLISH is issued when REGISTER is saved
				in location table.
			</p><p>
			</p><div class="example"><a name="id249062"></a><p class="title"><b>Example 1.4. <code class="function">pua_set_publish</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if(is_method("REGISTER") &amp;&amp; from_uri=~"john@opensips.org") 
	pua_set_publish();
...
</pre></div></div><br class="example-break"></div></div></div></div></body></html>
