<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Presence User Agent for XMPP (Presence gateway between SIP and XMPP)</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id247989"></a>Presence User Agent for XMPP (Presence gateway between SIP and XMPP)</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Anca-Maria</span> <span class="surname">Vamanu</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Anca-Maria</span> <span class="surname">Vamanu</span></h3></div></div></div><div><p class="copyright">Copyright © 2007 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id274767">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id270377">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id277594">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id284371">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248012">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248936">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248942">1.3.1. <code class="varname">server_address</code>(str)</a></span></dt><dt><span class="section"><a href="#id248972">1.3.2. <code class="varname">presence_server</code> (str)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249002">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id249011">1.4.1. 
		<code class="function">pua_xmpp_notify()</code>
		</a></span></dt><dt><span class="section"><a href="#id249050">1.4.2. 
		<code class="function">pua_xmpp_req_winfo(char* request_uri, char* expires)</code>
		</a></span></dt></dl></dd><dt><span class="section"><a href="#id249098">1.5.  Filtering </a></span></dt></dl></dd><dt><span class="chapter"><a href="#id248883">2. Developer Guide</a></span></dt></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248953">Set <code class="varname">server_address</code> parameter</a></dt><dt>1.2. <a href="#id248985">Set <code class="varname">presence_server</code> parameter</a></dt><dt>1.3. <a href="#id249029"><code class="function">Notify2Xmpp</code> usage</a></dt><dt>1.4. <a href="#id249074"><code class="function">xmpp_send_winfo</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id274767"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id270377"></a>1.1. Overview</h2></div></div></div><p>
		This module is a gateway for presence between SIP and XMPP.  
	</p><p>
		It translates one format into another and uses xmpp, pua and presence
		modules to manage the transmition of presence state information. 
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id277594"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id284371"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>presence</em></span>.
			</p></li><li><p>
				<span class="emphasis"><em>pua</em></span>.
			</p></li><li><p>
				<span class="emphasis"><em>xmpp</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248012"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>libxml</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248936"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248942"></a>1.3.1. <code class="varname">server_address</code>(str)</h3></div></div></div><p>
		The IP address of the server. 
		</p><div class="example"><a name="id248953"></a><p class="title"><b>Example 1.1. Set <code class="varname">server_address</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pua_xmpp", "server_address", "sip:sa@opensips.org:5060")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248972"></a>1.3.2. <code class="varname">presence_server</code> (str)</h3></div></div></div><p>
		The the address of the presence server. If set, it will be
		used as outbound proxy when sending PUBLISH requests.
		</p><div class="example"><a name="id248985"></a><p class="title"><b>Example 1.2. Set <code class="varname">presence_server</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("pua_xmpp", "presence_server", "sip:pa@opensips.org:5075")
...
	</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249002"></a>1.4. Exported Functions</h2></div></div></div><p>
	Functions exported to be used in configuration file.
	</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249011"></a>1.4.1. 
		<code class="function">pua_xmpp_notify()</code>
		</h3></div></div></div><p>
		Function that handles Notify messages addressed to a user from
		an xmpp domain. It requires filtering after method and domain in
		configuration file. If the function is successful, a 2xx reply must
		be sent.  
		</p><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id249029"></a><p class="title"><b>Example 1.3. <code class="function">Notify2Xmpp</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
	if( is_method("NOTIFY") &amp;&amp; uri=~"sip:.+@sip-xmpp.siphub.ro")
	{
		if(Notify2Xmpp())
			t_reply("200", "OK");
		exit;
	}
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249050"></a>1.4.2. 
		<code class="function">pua_xmpp_req_winfo(char* request_uri, char* expires)</code>
		</h3></div></div></div><p>
		Function called when a Subscribe addressed to a user from a
		xmpp domain is received. It calls sending a Subscribe for 
		winfo for the user, and the following Notify with dialog-info
		is translated into a subscription in xmpp. 
		It also requires filtering in configuration file, after method, 
		domain and event(only for presence).
		</p><p>
		It takes 2 parameters: request_uri and the value of Expires header field 
		in received Subscribe.
		</p><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id249074"></a><p class="title"><b>Example 1.4. <code class="function">xmpp_send_winfo</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
	if( is_method("SUBSCRIBE"))
	{
		handle_subscribe();
		if(uri=~"sip:.+@sip-xmpp.siphub.ro" &amp;&amp; $hdr(Event)== "presence")
		{
			pua_xmpp_req_winfo("$ruri", "$hdr(Expires)");
		}
		t_release();
	}

...
		</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249098"></a>1.5.  Filtering </h2></div></div></div><p> 
	Instead of "sip-xmpp.siphub.ro"  in the example you should use the value
	set for the xmpp module parameter named 'gateway_domain'.
	</p></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id248883"></a>Chapter 2. Developer Guide</h2></div></div></div><p>
		The module provides no function to be used in other OpenSIPS modules.
   </p></div></div></body></html>
