<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>ratelimit Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id247984"></a>ratelimit Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3></div><div class="author"><h3 class="author"><span class="firstname">Bogdan Vasile</span> <span class="surname">Harjoc</span></h3></div><div class="author"><h3 class="author"><span class="firstname">Hendrik</span> <span class="surname">Scholz</span></h3></div><div class="author"><h3 class="author"><span class="firstname">Razvan</span> <span class="surname">Crainea</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Ovidiu</span> <span class="surname">Sas</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Bogdan Vasile</span> <span class="surname">Harjoc</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Hendrik</span> <span class="surname">Scholz</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Razvan</span> <span class="surname">Crainea</span></h3></div></div></div><div><p class="copyright">Copyright © 2006 Freenet Cityline GmbH</p></div><div><p class="copyright">Copyright © 2008 VoIP Embedded Inc.</p></div><div><p class="copyright">Copyright © 2011 OpenSIPS Foundation</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id249046">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id248721">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248741">1.2. Use Cases</a></span></dt><dt><span class="section"><a href="#id249093">1.3. Static Rate Limiting Algorithms</a></span></dt><dd><dl><dt><span class="section"><a href="#id249103">1.3.1. Tail Drop Algorithm (TAILDROP)</a></span></dt><dt><span class="section"><a href="#id249122">1.3.2. Random Early Detection Algorithm (RED)</a></span></dt><dt><span class="section"><a href="#id249137">1.3.3. Network Algorithm (NETWORK)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249151">1.4. Dynamic Rate Limiting Algorithms</a></span></dt><dd><dl><dt><span class="section"><a href="#id249169">1.4.1. Feedback Algorithm (FEEDBACK)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249199">1.5. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249204">1.5.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249986">1.5.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id250012">1.6. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id250017">1.6.1. <code class="varname">timer_interval</code> (integer)</a></span></dt><dt><span class="section"><a href="#id250057">1.6.2. <code class="varname">expire_time</code> (integer)</a></span></dt><dt><span class="section"><a href="#id250093">1.6.3. <code class="varname">hash_size</code> (integer)</a></span></dt><dt><span class="section"><a href="#id250130">1.6.4. <code class="varname">default_algorithm</code> (string)</a></span></dt><dt><span class="section"><a href="#id250169">1.6.5. <code class="varname">cachedb_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id250205">1.6.6. <code class="varname">db_prefix</code> (string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id250243">1.7. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id250248">1.7.1. 
			<code class="function">rl_check(name, limit[, algorithm])
			</code>
		</a></span></dt><dt><span class="section"><a href="#id250343">1.7.2. 
		<code class="function">rl_dec_count(name)</code>
		</a></span></dt><dt><span class="section"><a href="#id250399">1.7.3. 
		<code class="function">rl_reset_count(name)</code>
		</a></span></dt></dl></dd><dt><span class="section"><a href="#id250455">1.8. Exported MI Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id250461">1.8.1. 
		<code class="function">rl_list</code>
		</a></span></dt><dt><span class="section"><a href="#id250514">1.8.2. 
		<code class="function">rl_reset_pipe</code>
		</a></span></dt><dt><span class="section"><a href="#id293750">1.8.3. 
		<code class="function">rl_set_pid</code>
		</a></span></dt><dt><span class="section"><a href="#id293810">1.8.4. 
		<code class="function">rl_get_pid</code>
		</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id250040">Set <code class="varname">timer_interval</code> parameter</a></dt><dt>1.2. <a href="#id250076">Set <code class="varname">expire_time</code> parameter</a></dt><dt>1.3. <a href="#id250113">Set <code class="varname">hash_size</code> parameter</a></dt><dt>1.4. <a href="#id250152">Set <code class="varname">default_algorithm</code> parameter</a></dt><dt>1.5. <a href="#id250188">Set <code class="varname">cachedb_url</code> parameter</a></dt><dt>1.6. <a href="#id250225">Set <code class="varname">db_prefix</code> parameter</a></dt><dt>1.7. <a href="#id250318"><code class="function">rl_check</code> usage</a></dt><dt>1.8. <a href="#id250380"><code class="function">rl_dec_count</code> usage</a></dt><dt>1.9. <a href="#id250435"><code class="function">rl_reset_count</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id249046"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248721"></a>1.1. Overview</h2></div></div></div><p>
		This module implements rate limiting for SIP requests. In contrast to
		the PIKE module this limits the flow based on a per SIP request type
		basis and not per source IP. The latest sources allow you to 
		dynamically group several messages into some entities and limit the
		traffic based on them. The MI interface can be used to change 
		tunables while running OpenSIPS.
	</p><p>
		This module is also integrated with the OpenSIPS Key-Value Interface,
		providing support for distributed rate limiting using Redis or Memcached
		CacheDB backends.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248741"></a>1.2. Use Cases</h2></div></div></div><p>
		Limiting the rate messages are processed on a system directly
		influences the load. The ratelimit module can be used to protect a
		single host or to protect an OpenSIPS cluster when run on the
		dispatching box in front.
	</p><p>
		Distributed limiting is useful when the rate limit should be
		performed not only on a specific node, but on the entire platform. 
		The internal limiting data will no longer be kept on each OpenSIPS 
		instance. It will be stored in a distributed Key-Value database and
		queried by each instance before deciding if a SIP message 
		should be blocked or not.
	</p><p>
		NOTE: that this behavior only makes sense when the pipe algorithm
		used is TAILDROP or RED.
	</p><p>
		A sample configuration snippet might look like this:
	</p><pre class="programlisting">
...
	if (!rl_check("$rU", "50", "TAILDROP")) {
		sl_send_reply("503", "Server Unavailable");
		exit;
	};
...
	</pre><p>
		Upon every incoming request listed above rl_check is invoked and
		the entity identified by the R-URI user is checked. It
		returns an OK code if the current per request load is below the
		configured threshold. If the load is exceeded the function returns an
		error and an administrator can discard requests with a stateless
		response.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249093"></a>1.3. Static Rate Limiting Algorithms</h2></div></div></div><p>
		The ratelimit module supports two different static algorithms
		to be used by rl_check to determine whether a message should be
		blocked or not.
	</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249103"></a>1.3.1. Tail Drop Algorithm (TAILDROP)</h3></div></div></div><p>
		This is a trivial algorithm that imposes some risks when used in
		conjunction with long timer intervals. At the start of each interval
		an internal counter is reset and incremented for each incoming
		message. Once the counter hits the configured limit rl_check returns
		an error.
		</p><p>
		The downside of this algorithm is that it can lead to SIP client
		synchronization. During a relatively long interval only the first
		requests (i.e. REGISTERs) would make it through. Following messages
		(i.e. RE-REGISTERs) will all hit the SIP proxy at the same time when a
		common Expire timer expired. Other requests will be retransmissed
		after given time, the same on all devices with the same firmware/by
		the same vendor.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249122"></a>1.3.2. Random Early Detection Algorithm (RED)</h3></div></div></div><p>
		Random Early Detection tries to circumvent the synchronization problem
		imposed by the tail drop algorithm by measuring the average load and
		adapting the drop rate dynamically. When running with the RED
		algorithm OpenSIPS will return errors to the OpenSIPS
		routing engine every n'th packet trying to evenly spread the measured
		load of the last timer interval onto the current interval. As a
		negative side effect OpenSIPS might drop messages although the limit might
		not be reached within the interval. Decrease the timer interval if you
		encounter this.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249137"></a>1.3.3. Network Algorithm (NETWORK)</h3></div></div></div><p>
		This algorithm relies on information provided by network interfaces.
		The total amount of bytes waiting to be consumed on all the network
		interfaces is retrieved once every timer_interval seconds.
		If the returned amount exceeds the limit specified in the modparam,
		rl_check returns an error. 
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249151"></a>1.4. Dynamic Rate Limiting Algorithms</h2></div></div></div><p>
		When running OpenSIPS on different machines, one has to adjust the drop
		rates for the static algorithms to maintain a sub 100% load average or
		packets start getting dropped in the network stack.  While this is not
		in itself difficult, it isn't neither accurate nor trivial: another
		server taking a notable fraction of the cpu time will require re-tuning
		the parameters.
	</p><p>
		While tuning the drop rates from the outside based on a certain factor
		is possible, having the algorithm run inside ratelimit permits tuning
		the rates based on internal server parameters and is somewhat more
		flexible (or it will be when support for external load factors - as
		opposed to cpu load - is added).
	</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249169"></a>1.4.1. Feedback Algorithm (FEEDBACK)</h3></div></div></div><p>
		Using the PID Controller model
		(see <a class="ulink" href="http://en.wikipedia.org/wiki/PID_controller" target="_top">Wikipedia page</a>),
		the drop rate is adjusted dynamically based on the load factor so that
		the load factor always drifts towards the specified limit (or setpoint,
		in PID terms).
		</p><p>
		As reading the cpu load average is relatively expensive (opening /proc/stat,
		parsing it, etc), this only happens once every timer_interval seconds and
		consequently the FEEDBACK value is only at these intervals recomputed. This
		in turn makes it difficult for the drop rate to adjust quickly.  Worst case
		scenarios are request rates going up/down instantly by thousands - it takes
		up to 20 seconds for the controller to adapt to the new request rate.
		</p><p>
		Generally though, as real life request rates drift by less, adapting should
		happen much faster.
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249199"></a>1.5. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249204"></a>1.5.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249986"></a>1.5.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id250012"></a>1.6. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250017"></a>1.6.1. <code class="varname">timer_interval</code> (integer)</h3></div></div></div><p>
		The initial length of a timer interval in seconds. All amounts of
		messages have to be divided by this timer to get a messages per second
		value.
		</p><p>
		IMPORTANT: A too small value may lead to performance penalties due to
		timer process overloading.
		</p><p>
		<span class="emphasis"><em>
			Default value is 10.
		</em></span>
		</p><div class="example"><a name="id250040"></a><p class="title"><b>Example 1.1. Set <code class="varname">timer_interval</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("ratelimit", "timer_interval", 5)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250057"></a>1.6.2. <code class="varname">expire_time</code> (integer)</h3></div></div></div><p>
		This parameter specifies how long a pipe should be kept in memory
		until deleted. 
		</p><p>
		<span class="emphasis"><em>
			Default value is 3600.
		</em></span>
		</p><div class="example"><a name="id250076"></a><p class="title"><b>Example 1.2. Set <code class="varname">expire_time</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("ratelimit", "expire_time", 1800)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250093"></a>1.6.3. <code class="varname">hash_size</code> (integer)</h3></div></div></div><p>
		The size of the hash table internally used to keep the pipes.
		A larger table is much faster but consumes more memory. The hash size
		must be a power of 2 number.
		</p><p>
		<span class="emphasis"><em>
			Default value is 1024.
		</em></span>
		</p><div class="example"><a name="id250113"></a><p class="title"><b>Example 1.3. Set <code class="varname">hash_size</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("ratelimit", "hash_size", 512)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250130"></a>1.6.4. <code class="varname">default_algorithm</code> (string)</h3></div></div></div><p>
		Specifies which algorithm should be assumed in case it isn't 
		explicitly specified in the <span class="emphasis"><em>rl_check</em></span> function.
		</p><p>
		<span class="emphasis"><em>
			Default value is "TAILDROP".
		</em></span>
		</p><div class="example"><a name="id250152"></a><p class="title"><b>Example 1.4. Set <code class="varname">default_algorithm</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("ratelimit", "default_algorithm", "RED")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250169"></a>1.6.5. <code class="varname">cachedb_url</code> (string)</h3></div></div></div><p>
		Enables distributed rate limiting and specifies the backend
		that should be used by the CacheDB interface.
		</p><p>
		<span class="emphasis"><em>
			Default value is "disabled".
		</em></span>
		</p><div class="example"><a name="id250188"></a><p class="title"><b>Example 1.5. Set <code class="varname">cachedb_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("ratelimit", "cachedb_url", "redis://root:root@127.0.0.1/")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250205"></a>1.6.6. <code class="varname">db_prefix</code> (string)</h3></div></div></div><p>
		Specifies what prefix should be added to the pipe name. This is
		only used when distributed rate limiting is enabled.
		</p><p>
		<span class="emphasis"><em>
			Default value is "rl_pipe_".
		</em></span>
		</p><div class="example"><a name="id250225"></a><p class="title"><b>Example 1.6. Set <code class="varname">db_prefix</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("ratelimit", "db_prefix", "ratelimit_")
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id250243"></a>1.7. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250248"></a>1.7.1. 
			<code class="function">rl_check(name, limit[, algorithm])
			</code>
		</h3></div></div></div><p>
		Check the current request against the pipe identified by name and
		changes/updates the limit. If no pipe is found, then a new one is
		created with the specified limit and algorithm, if specified. If the 
		algorithm parameter doesn't exist, the default one is used.
		</p><p>
		NOTE: A pipe's algorithm cannot be dynamically changed. Only the one
		specified when the pipe was created will be considered.
		</p><p>
		The method will return an error code if the limit for the
		matched pipe is reached.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>name</em></span> - this is the name that identifies
				the pipe which should be checked. This parameter accepts both
				strings and pseudovariables.
				</p></li><li><p>
				<span class="emphasis"><em>limit</em></span> - this specifies the threshold
				limit of the pipe. It is strongly related to the algorithm
				used. This parameter accepts an integer or a pseudovariable.
				Note that the limit should be specified as per-second, not
				per-timer_interval.
				</p></li><li><p>
				<span class="emphasis"><em>algorithm</em></span> - this is parameter is optional
				and reffers to the algorithm used to check the pipe. If it is
				not set, the default value is used. It accepts a string or a 
				pseudovariable.
				</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id250318"></a><p class="title"><b>Example 1.7. <code class="function">rl_check</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
	# perform a pipe match for all INVITE methods using RED algorithm
	if (is_method("INVITE")) {
		if (!rl_check("pipe_INVITE", "100", "RED")) {
			sl_send_reply("503", "Server Unavailable");
			exit;
		};
	};
...
	# use default algorithm for each different gateway
	$var(limit) = 10;
	if (!rl_check("gw_$ru", "$var(limit)")) {
		sl_send_reply("503", "Server Unavailable");
		exit;
	};
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250343"></a>1.7.2. 
		<code class="function">rl_dec_count(name)</code>
		</h3></div></div></div><p>
		This function decreases a counter that could have been previously
		increased by <span class="emphasis"><em>rl_check</em></span> function.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>name</em></span> - identifies the name of the pipe.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id250380"></a><p class="title"><b>Example 1.8. <code class="function">rl_dec_count</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
	if (!rl_check("gw_$ru", "100", "TAILDROP")) {
		exit;
	} else {
		rl_dec_count("gw_$ru");
	};
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250399"></a>1.7.3. 
		<code class="function">rl_reset_count(name)</code>
		</h3></div></div></div><p>
		This function resets a counter that could have been previously
		increased by <span class="emphasis"><em>rl_check</em></span> function.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>name</em></span> - identifies the name of the pipe.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id250435"></a><p class="title"><b>Example 1.9. <code class="function">rl_reset_count</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
	if (!rl_check("gw_$ru", "100", "TAILDROP")) {
		exit;
	} else {
		rl_reset_count("gw_$ru");
	};
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id250455"></a>1.8. Exported MI Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250461"></a>1.8.1. 
		<code class="function">rl_list</code>
		</h3></div></div></div><p>
		Lists the parameters and variabiles in the ratelimit module.
		</p><p>
		Name: <span class="emphasis"><em>rl_list</em></span>
		</p><p>Parameters:</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>pipe</em></span> - indicates the name of the pipe. This
			parameter is optional. If it doesn't exist, all the active pipes
			are listed. Otherwise only the one specified.
			</p></li></ul></div><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
		:rl_list:_reply_fifo_file_
		gw_10.0.0.1
		_empty_line_
		</pre><pre class="programlisting">
		:rl_list:_reply_fifo_file_
		_empty_line_
		</pre></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id250514"></a>1.8.2. 
		<code class="function">rl_reset_pipe</code>
		</h3></div></div></div><p>
		Resets the counter of a specified pipe.
		</p><p>
		Name: <span class="emphasis"><em>rl_reset_pipe</em></span>
		</p><p>Parameters:</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>pipe</em></span> - indicates the name of the pipe whose
			couter should be reset.
			</p></li></ul></div><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
		:rl_reset_pipe:_reply_fifo_file_
		gw_10.0.0.1
		_empty_line_
		</pre></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293750"></a>1.8.3. 
		<code class="function">rl_set_pid</code>
		</h3></div></div></div><p>
		Sets the PID Controller parameters for the Feedback Algorithm.
		</p><p>
		Name: <span class="emphasis"><em>rl_set_pid</em></span>
		</p><p>Parameters:</p><div class="itemizedlist"><ul type="disc"><li><p>
			<span class="emphasis"><em>ki</em></span> - the integral parameter.
			</p></li><li><p>
			<span class="emphasis"><em>kp</em></span> - the proportional parameter.
			</p></li><li><p>
			<span class="emphasis"><em>kd</em></span> - the derivative parameter.
			</p></li></ul></div><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
		:rl_set_pid:_reply_fifo_file_
		0.5
		0.5
		0.5
		_empty_line_
		</pre></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293810"></a>1.8.4. 
		<code class="function">rl_get_pid</code>
		</h3></div></div></div><p>
		Gets the list of in use PID Controller parameters.
		</p><p>
		Name: <span class="emphasis"><em>rl_get_pid</em></span>
		</p><p>Parameters: <span class="emphasis"><em>none</em></span></p><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
		:rl_get_pid:_reply_fifo_file_
		_empty_line_
		</pre></div></div></div></div></body></html>
