<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>signaling Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id247984"></a>signaling Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Anca-Maria</span> <span class="surname">Vamanu</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Anca-Maria</span> <span class="surname">Vamanu</span></h3></div></div></div><div><p class="copyright">Copyright © 2008 FhG FOKUS</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id274823">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id276434">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248319">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248325">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248017">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248942">1.3. Exported Parameters</a></span></dt><dt><span class="section"><a href="#id248966">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id248971">1.4.1. 
		<code class="function">send_reply(code, reason)</code>
		</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249018"><code class="function">sl_send_reply</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id274823"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id276434"></a>1.1. Overview</h2></div></div></div><p>
		The <acronym class="acronym">SIGNALING</acronym> module comes as a wrapper over 
		tm and sl modules and offers one function to be called by the modules
		that want to send a reply. 
	</p><p>
		The logic behind th emodule is to first search if a transaction is
		created and if so, send a state full reply, using tm module, otherwise
		send a stateless reply with the function exported by sl.
		In this way, the script writer still has the call on how the transaction 
		should be handled, state full or stateless and the reply is send 
		accordingly to his choice.
	</p><p>
		For example, if you do a t_newtran() in the script before doing save() 
		(for registration), the function will automatically send the reply in 
		stateful mode as a transaction is available. If no transaction is done, 
		the reply will be sent in stateless way (as now).
	</p><p>
		By doing this, we have the possibility to have same module sending 
		either stateful either stateless replies, by just controlling this from 
		the script (if we create or not a transaction).
		So, the signalling will be more coherent as the replies will be sent 
		according to the transaction presence (or not).
	</p><p>
	Moreover, this module offers the possibility of loading only one 
	of the module, sl or tm, and send reply using only the module that is 
	loaded. This is useful as not in all cases a user desires to send 
	stateful or stateless replies and he should not be forced to load the 
	module only because the send reply interface requires it.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248319"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248325"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		At least one of the following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>sl</em></span>.
			</p></li><li><p>
				<span class="emphasis"><em>tm</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248017"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248942"></a>1.3. Exported Parameters</h2></div></div></div><p>
		</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248966"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248971"></a>1.4.1. 
		<code class="function">send_reply(code, reason)</code>
		</h3></div></div></div><p>
		For the current request, a reply is sent back having the given code 
		and text reason. The reply is sent stateless or statefull depending 
		on which module is loaded and if a transaction was created, as 
		explained above.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>code</em></span> - Return code.
			</p></li><li><p><span class="emphasis"><em>reason</em></span> - Reason phrase.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE, ERROR_ROUTE.
		</p><div class="example"><a name="id249018"></a><p class="title"><b>Example 1.1. <code class="function">sl_send_reply</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
send_reply("404", "Not found");
...
send_reply("$err.rcode", "$err.rreason");
...
		</pre></div></div><br class="example-break"></div></div></div></div></body></html>
