<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>sl Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id248507"></a>sl Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Bogdan</span> <span class="surname">Iancu</span></h3></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Bogdan</span> <span class="surname">Iancu</span></h3></div></div></div><div><p class="copyright">Copyright © 2003 FhG FOKUS</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date: 2013-01-29 13:35:11 +0100 (Tue, 29 Jan 2013) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id248327">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id284357">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248006">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248016">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248938">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248963">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248969">1.3.1. <code class="varname">enable_stats</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249006">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id249012">1.4.1. 
		<code class="function">sl_send_reply(code, reason)</code>
		</a></span></dt><dt><span class="section"><a href="#id249074">1.4.2. 
		<code class="function">sl_reply_error()</code>
		</a></span></dt></dl></dd><dt><span class="section"><a href="#id249113">1.5. Exported Statistics</a></span></dt><dd><dl><dt><span class="section"><a href="#id249118">1.5.1. <code class="varname">1xx_replies</code></a></span></dt><dt><span class="section"><a href="#id249130">1.5.2. <code class="varname">2xx_replies</code></a></span></dt><dt><span class="section"><a href="#id249141">1.5.3. <code class="varname">3xx_replies</code></a></span></dt><dt><span class="section"><a href="#id249152">1.5.4. <code class="varname">4xx_replies</code></a></span></dt><dt><span class="section"><a href="#id249164">1.5.5. <code class="varname">5xx_replies</code></a></span></dt><dt><span class="section"><a href="#id249175">1.5.6. <code class="varname">6xx_replies</code></a></span></dt><dt><span class="section"><a href="#id249944">1.5.7. <code class="varname">sent_replies</code></a></span></dt><dt><span class="section"><a href="#id249955">1.5.8. <code class="varname">sent_err_replies</code></a></span></dt><dt><span class="section"><a href="#id249967">1.5.9. <code class="varname">received_ACKs</code></a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248989">enable_stats example</a></dt><dt>1.2. <a href="#id249056"><code class="function">sl_send_reply</code> usage</a></dt><dt>1.3. <a href="#id249093"><code class="function">sl_reply_error</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id248327"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284357"></a>1.1. Overview</h2></div></div></div><p>
		The <acronym class="acronym">SL</acronym> module allows OpenSIPS to act as a stateless 
		<acronym class="acronym">UA</acronym> server and generate replies to <acronym class="acronym">SIP</acronym> requests without keeping 
		state. That is beneficial in many scenarios, in which you wish not to 
		burden server's memory and scale well.
	</p><p>
		The <acronym class="acronym">SL</acronym> module needs to filter ACKs sent after a 
		local stateless reply to an INVITE was generated. To recognize such 
		ACKs, OpenSIPS adds a special "signature" in to-tags. This signature is 
		sought for in incoming ACKs, and if included, the ACKs are absorbed.
	</p><p>
		To speed up the filtering process, the module uses a timeout 
		mechanism. When a reply is sent, a timer is set. As time as the timeout 
		didn't hit, the incoming ACK requests will be checked using TO tag 
		value. Once the timer expires, all the ACK are let through - a long
		time passed till it sent a reply, so it does not expect any ACK that 
		have to be blocked.
	</p><p>
		The ACK filtering may fail in some rare cases. If you think these 
		matter to you, better use stateful processing (tm module) for INVITE 
		processing. Particularly, the problem happens when a UA sends an 
		INVITE which already has a to-tag in it (e.g., a re-INVITE)
		and OpenSIPS want to reply to it. Than, it will keep the current to-tag, 
		which will be mirrored in ACK. OpenSIPS will not see its signature and 
		forward the ACK downstream. Caused harm is not bad--just a useless 
		ACK is forwarded.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248006"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248016"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248938"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248963"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248969"></a>1.3.1. <code class="varname">enable_stats</code> (integer)</h3></div></div></div><p>
		If the module should generate and export statistics to the core
		manager. A zero value means disabled.
		</p><p>
		SL module provides statistics about how many replies were sent (
		splitted per code classes) and how many local ACKs were filtered out.
		</p><p>
		Default value is 1 (enabled).
		</p><div class="example"><a name="id248989"></a><p class="title"><b>Example 1.1. enable_stats example</b></p><div class="example-contents"><pre class="programlisting">
modparam("sl", "enable_stats", 0)
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249006"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249012"></a>1.4.1. 
		<code class="function">sl_send_reply(code, reason)</code>
		</h3></div></div></div><p>
		For the current request, a reply is sent back having the given code 
		and text reason. The reply is sent stateless, totally independent of 
		the Transaction module and with no retransmission for the INVITE's 
		replies. 'code' and 'reason' can contain pseudo-variables that are
		replaced at runtime.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>code</em></span> - Return code.
			</p></li><li><p><span class="emphasis"><em>reason</em></span> - Reason phrase.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE, ERROR_ROUTE.
		</p><div class="example"><a name="id249056"></a><p class="title"><b>Example 1.2. <code class="function">sl_send_reply</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
sl_send_reply("404", "Not found");
...
sl_send_reply("$err.rcode", "$err.rreason");
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249074"></a>1.4.2. 
		<code class="function">sl_reply_error()</code>
		</h3></div></div></div><p>
		Sends back an error reply describing the nature of the last internal 
		error.  Usually this function should be used after a script function 
		that returned an error code.
		</p><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id249093"></a><p class="title"><b>Example 1.3. <code class="function">sl_reply_error</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
sl_reply_error();
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249113"></a>1.5. Exported Statistics</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249118"></a>1.5.1. <code class="varname">1xx_replies</code></h3></div></div></div><p>
		The number of 1xx_replies.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249130"></a>1.5.2. <code class="varname">2xx_replies</code></h3></div></div></div><p>
		The number of 2xx_replies.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249141"></a>1.5.3. <code class="varname">3xx_replies</code></h3></div></div></div><p>
		The number of 3xx_replies.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249152"></a>1.5.4. <code class="varname">4xx_replies</code></h3></div></div></div><p>
		The number of 4xx_replies.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249164"></a>1.5.5. <code class="varname">5xx_replies</code></h3></div></div></div><p>
		The number of 5xx_replies.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249175"></a>1.5.6. <code class="varname">6xx_replies</code></h3></div></div></div><p>
		The number of 6xx_replies.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249944"></a>1.5.7. <code class="varname">sent_replies</code></h3></div></div></div><p>
		The number of sent_replies.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249955"></a>1.5.8. <code class="varname">sent_err_replies</code></h3></div></div></div><p>
		The number of sent_err_replies.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249967"></a>1.5.9. <code class="varname">received_ACKs</code></h3></div></div></div><p>
		The number of received_ACKs.
		</p></div></div></div></div></body></html>
